<?php

// +---------------------------------------------------------------------------+
// | Universal Geeklog Plugin 1.0                                              |
// +---------------------------------------------------------------------------+
// | admin/index.php                                                           |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');


// Only let admin users access this page
if (!SEC_hasRights('testimonials.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the testimonials Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_TSTM01['access_denied']);
    $display .= $LANG_TSTM01['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

// show list of testimonials
function listEntries ()
{
    global $_CONF, $_TABLES, $LANG_TSTM01;

    $retval = '';

    $templates = new Template ($_CONF['path'] . 'plugins/testimonials/templates');
    $templates->set_file (array ('list' => 'admin.thtml',
                                 'row'  => 'adminitem.thtml'
                         ));
    $templates->set_var ('site_url', $_CONF['site_url']);
    $templates->set_var ('site_admin_url', $_CONF['site_admin_url']);
    $templates->set_var ('layout_url', $_CONF['layout_url']);


    $templates->set_var ('edit', $LANG_TSTM01['edit']);
    $templates->set_var ('client', $LANG_TSTM01['client']);
    $templates->set_var ('company', $LANG_TSTM01['company']);
    $templates->set_var ('tstdate', $LANG_TSTM01['tstdate']);

    $result = DB_query ("SELECT testid,clientname,company,tst_date,views FROM " . $_TABLES['testimonials'] . " ORDER BY tst_date DESC");
    $num = DB_numRows ($result);

    for ($i = 0; $i < $num; $i++) {
        $A = DB_fetchArray ($result);

        $templates->set_var ('row_num', $lcount);
        $templates->set_var ('cssid', ($i % 2) + 1);
        $templates->set_var ('row_testid', $A['testid']);
        $templates->set_var ('row_client', $A['clientname']);
        $templates->set_var ('row_company', $A['company']);
        $templates->set_var ('row_tstdate', $A['tst_date']);

        $url = $_CONF['site_admin_url'] . '/plugins/testimonials/index.php?mode=edit&amp;testid=' . $A['testid'];

        $templates->set_var ('start_headers_anchortag', '<a href="' . $url . '">');
        $templates->set_var ('end_headers_anchortag', '</a>');

        $templates->parse ('log_row', 'row', true);
    }

    $templates->parse('output', 'list');
    $retval .= $templates->finish($templates->get_var('output'));

    return $retval;
}

function delEntry($testid)
{
    global $_CONF, $_TABLES;
    DB_query ("delete from {$_TABLES['testimonials']} where testid = '$testid'");
	return COM_refresh ($_CONF['site_admin_url'] . '/plugins/testimonials/index.php');
}

function editEntryDo($testid,$clientname,$company,$testurl,$tstdate,$text_short,$text_full)
{
    global $_CONF, $_TABLES, $LANG_TSTM01;
    $text_full = addslashes (COM_checkHTML (COM_checkWords ($text_full)));
	$text_short = addslashes (COM_checkHTML (COM_checkWords ($text_short)));
    $company = addslashes (COM_checkHTML (COM_checkWords ($company)));
    $clientname = addslashes ($clientname);
	
    if ($testid=='') {
    DB_save ($_TABLES['testimonials'],'clientname,company,homepage,tst_date,text_short,text_full,views',"'$clientname','$company','$testurl','$tstdate','$text_short','$text_full','0'");
    } else {
	DB_query ("update {$_TABLES['testimonials']} set clientname='$clientname',company='$company',homepage='$testurl',tst_date='$tstdate',text_short='$text_short',text_full='$text_full' where testid = '$testid'");
	}
	return COM_refresh ($_CONF['site_admin_url'] . '/plugins/testimonials/index.php');
}

function editEntry($mode,$testid='')
{
    global $_CONF, $_TABLES, $LANG_TSTM01;

    $retval = '';

    $templates = new Template ($_CONF['path'] . 'plugins/testimonials/templates');
    $templates->set_file ('form','newentry.thtml');
    $templates->set_var ('site_url', $_CONF['site_url']);
    $templates->set_var ('site_admin_url', $_CONF['site_admin_url']);
    $templates->set_var ('layout_url', $_CONF['layout_url']);
	$templates->set_var ('client_text', $LANG_TSTM01['client']);
	$templates->set_var ('client_help', $LANG_TSTM01['client_help']);
	$templates->set_var ('company_text', $LANG_TSTM01['company']);
	$templates->set_var ('company_help', $LANG_TSTM01['company_help']);
	$templates->set_var ('testa_text_short', $LANG_TSTM01['text_short']);
	$templates->set_var ('text_short_help', $LANG_TSTM01['text_short_help']);
	$templates->set_var ('testa_text_full', $LANG_TSTM01['text_full']);
	$templates->set_var ('text_full_help', $LANG_TSTM01['text_full_help']);
	$templates->set_var ('testdate_text', $LANG_TSTM01['tstdate']);
	$templates->set_var ('url_text', $LANG_TSTM01['homepage']);
	$templates->set_var ('url_help', $LANG_TSTM01['homepage_help']);
	$templates->set_var ('date_help', 'yyyy-mm-dd format');
	$templates->set_var ('lang_save', $LANG_TSTM01['save']);
	$templates->set_var ('lang_cancel', $LANG_TSTM01['cancel']);

    if ($mode == 'edit') {
            $result = DB_query ("SELECT * FROM {$_TABLES['testimonials']} WHERE testid = '$testid'");
            $A = DB_fetchArray($result);
        } else {
            $A['testid'] = '';
			$A['clientname'] = '';
            $A['company'] = '';
			$A['homepage'] = '';
            $A['tst_date'] = '';
            $A['text_short']= '';
			$A['text_full']= '';
        }
	$templates->set_var ('row_testid', $A['testid']);
	$templates->set_var ('row_client', $A['clientname']);
	$templates->set_var ('row_company', $A['company']);
	$templates->set_var ('row_testurl', $A['homepage']);
	$templates->set_var ('row_tstdate', $A['tst_date']);
	$templates->set_var ('row_text_short', $A['text_short']);
	$templates->set_var ('row_text_full', $A['text_full']);

    if (!empty($testid) && SEC_hasRights('testimonials.admin')) {
        $templates->set_var ('delete_option', '<input type="submit" value="' . $LANG_TSTM01['delete'] . '" name="mode" onClick="return delconfirm()">');
    }

    if (!empty($testid)) {
        $templates->set_var ('cancel_option', '<input type="submit" value="' . $LANG_TSTM01['cancel'] . '" name="mode">');
    }
	
    $templates->parse('output', 'form');
    $retval .= $templates->finish($templates->get_var('output'));
    return $retval;
} 


// MAIN
$menu = '[ <a href="'.$_CONF['site_admin_url'] . '/plugins/testimonials/index.php">'.$LANG_TSTM01['plugin_admin'].'</a> ]&nbsp;'
		. '[ <a href="'.$_CONF['site_admin_url'] . '/plugins/testimonials/index.php?mode=edit">'.$LANG_TSTM01['create_new'].'</a> ]&nbsp;'
		. '[ <a href="'.$_CONF['site_admin_url'] . '/plugins/testimonials/install.html">'.$LANG_TSTM01['help_file'].'</a> ]';

$display .= COM_siteHeader ('menu', $LANG_TSTM01['admin']);
$display .= $menu.'<br><br>';

$mode = '';
if (isset ($_REQUEST['mode'])) {
    $mode = $_REQUEST['mode'];
}
if ($mode == 'edit') {
    if (empty ($_GET['testid'])) {
        $display .= editEntry ($mode);
    } else {
        $display .= editEntry ($mode, COM_applyFilter ($_GET['testid']));
    }
} elseif ($mode == 'Save') {
    $display .= editEntryDo ($_POST['testid'],
            $_POST['clientname'], $_POST['company'],
			$_POST['testurl'], $_POST['tstdate'],
			$_POST['text_short'],$_POST['text_full']);
} elseif ($mode == 'Delete') {
        $display .= delEntry ($_POST['testid']);
} else {
    $display .= listEntries ();
}

$display .= COM_siteFooter (false);

echo $display;
?>